<?php

include_once('../SmsService.php');

class Request
{
    private $xmlRequest;
    private $SMS = [];       //// SMS class object array to keep each sms infos
    private $usercode;
    private $password;
    private $title;
    private $url;
    private $language;

    function __construct($title, $SMS, $usercode, $password)
    {
        $this->title = $title;
        $this->SMS = $SMS;
        $this->usercode = $usercode;
        $this->password = $password;
        $this->setLanguage();
    }


    function XMLPOST()
    {
        
        $url = "https://smsgw.mutlucell.com/smsgw-ws/sndblkex";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml"));
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->xmlRequest);
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }

    function XMLPOSTOTP()
    {
       
//        header("Content-Type: text/xml");
//        echo ($this->getXmlOtpRequest());
//        exit;

        $url = "https://smsgw.mutlucell.com/smsgw-ws/sndblkex";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml"));
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->getXmlOtpRequest());
        $result = curl_exec($ch);

        if (curl_errno($ch)) {
            $error_msg = curl_error($ch);
        }
        curl_close($ch);

        if (isset($error_msg)) {
            return $error_msg;
        }

        return $result;
    }

    public static function HTTPGET($u, $p)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://smsgw.mutlucell.com/smsgw-ws/gtorgex');
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, Array("Content-Type: text/xml"));
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, '<?xml version="1.0" encoding="UTF-8"?><smsorig ka="' . $u . '" pwd="' . $p . '" />');

        $res = curl_exec($ch);
        curl_close($ch);

        return $res;

    }

    /**
     * @return mixed
     */
    public function getUsercode()
    {
        return $this->usercode;
    }

    /**
     * @return mixed
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * @return array
     */
    public function getSMS()
    {
        return $this->SMS;
    }

    /**
     * @return mixed
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * @return mixed
     */
    public function getXmlRequest()
    {
        return $this->xmlRequest;
    }

    public function setLanguage()
    {
        $service = new SmsService();
        $settings = $service->getSettings();
        $settingsRow = $settings->fetch();

        $this->language = trim($settingsRow['smslanguage']);
    }

    public function getLanguage()
    {
        return $this->language;
    }


    /**
     * Prepare Xml Request
     */
    public function prepareXMLRequest()
    {
        $this->xmlRequest = $this->getXmlRequestHeader();
        $this->xmlRequest .= $this->getXmlRequestBody();
    }

    function getXmlRequestHeader()
    {
        if ($this->getLanguage() == "tr") {
            $language = ' charset="turkish"';
        } else {
            $language = '';
        }
        try {
            $xmlHeader = '<?xml version="1.0" encoding="UTF-8"?>';
            $xmlHeader .= '<smspack ka="' . $this->getUsercode() . '"';
            $xmlHeader .= ' pwd="' . $this->getPassword() . '"';
            $xmlHeader .= ' org="' . $this->getTitle() . '"' . $language . '>';

            return $xmlHeader;
        } catch (Exception $e) {
            return 'XML HEADER ERROR';
        }

    }


    function getXmlRequestBody()
    {
        try {
            $xmlBody = '';
            foreach ($this->SMS as $SM) {

                if ($this->getLanguage() == "tr") {
                    $message = $SM->getMessage();
                } else {
                    $message = $this->replace_tr($SM->getMessage());
                }

                $xmlBody .= '<mesaj><metin>' . $message . '</metin><nums>' . $SM->getDestination() . '</nums></mesaj>';
            }
            $xmlBody .= '</smspack>';

            return $xmlBody;
        } catch (Exception $e) {
            return 'XML BODY ERROR';
        }
    }

    function getXmlOtpRequest()
    {
        $xmlOtpRequest = "";
        $xmlOtpRequest .= '<?xml version="1.0" encoding="UTF-8"?>';
        $xmlOtpRequest .= '<smspack ka="' . $this->getUsercode() . '"';
        $xmlOtpRequest .= ' pwd="' . $this->getPassword() . '"';
        $xmlOtpRequest .= ' org="' . $this->getTitle() . '">';
        foreach ($this->SMS as $SM) {
            $xmlOtpRequest .= '<mesaj><metin>' . $SM->getMessage() . '</metin>';
            $xmlOtpRequest .= '<nums>' . $SM->getDestination() . '</nums></mesaj>';
        }
        $xmlOtpRequest .= '</smspack>';

        return $xmlOtpRequest;
    }

    function replace_tr($text)
    {
        $text = trim($text);
        $search = array('Ç', 'ç', 'Ğ', 'ğ', 'ı', 'İ', 'Ö', 'ö', 'Ş', 'ş', 'Ü', 'ü');
        $replace = array('C', 'c', 'G', 'g', 'i', 'I', 'O', 'o', 'S', 's', 'U', 'u');
        $new_text = str_replace($search, $replace, $text);
//        $new_text = preg_replace("/[^a-zA-Z0-9.]+/", "", $new_text);

        return $new_text;
    }
}

?>
